import 'package:flutter/material.dart';
import 'package:syncrow_web/common/edit_chip.dart';
import 'package:syncrow_web/pages/space_management_v2/modules/space_details/domain/models/space_details_model.dart';
import 'package:syncrow_web/pages/space_management_v2/modules/space_details/presentation/widgets/button_content_widget.dart';
import 'package:syncrow_web/utils/color_manager.dart';
import 'package:syncrow_web/utils/constants/assets.dart';

class SpaceDetailsDevicesBox extends StatelessWidget {
  const SpaceDetailsDevicesBox({super.key, required this.space});

  final SpaceDetailsModel space;

  @override
  Widget build(BuildContext context) {
    if (space.productAllocations.isNotEmpty ||
        space.subspaces.any((subspace) => subspace.productAllocations.isNotEmpty)) {
      return Container(
        width: double.infinity,
        padding: const EdgeInsets.all(8.0),
        decoration: BoxDecoration(
          color: ColorsManager.textFieldGreyColor,
          borderRadius: BorderRadius.circular(15),
          border: Border.all(
            color: ColorsManager.textFieldGreyColor,
            width: 3.0,
          ),
        ),
        child: Wrap(
          spacing: 8.0,
          runSpacing: 8.0,
          children: [
            // Combine tags from spaceModel and subspaces
            // ...TagHelper.groupTags([
            //   ...?tags,
            //   ...?subspaces?.expand((subspace) => subspace.tags ?? [])
            // ]).entries.map(
            //   (entry) => Chip(
            //     avatar: SizedBox(
            //       width: 24,
            //       height: 24,
            //       child: SvgPicture.asset(
            //         entry.key.icon ?? 'assets/icons/gateway.svg',
            //         fit: BoxFit.contain,
            //       ),
            //     ),
            //     label: Text(
            //       'x${entry.value}',
            //       style: Theme.of(context)
            //           .textTheme
            //           .bodySmall
            //           ?.copyWith(color: ColorsManager.spaceColor),
            //     ),
            //     backgroundColor: ColorsManager.whiteColors,
            //     shape: RoundedRectangleBorder(
            //       borderRadius: BorderRadius.circular(16),
            //       side: const BorderSide(
            //         color: ColorsManager.spaceColor,
            //       ),
            //     ),
            //   ),
            // ),

            EditChip(
              onTap: () {},
            ),
          ],
        ),
      );
    } else {
      return TextButton(
        onPressed: () {},
        style: TextButton.styleFrom(
          padding: EdgeInsets.zero,
        ),
        child: const SizedBox(
          width: double.infinity,
          child: ButtonContentWidget(
            svgAssets: Assets.addIcon,
            label: 'Add Devices',
            // disabled: isTagsAndSubspaceModelDisabled,
          ),
        ),
      );
    }
  }
}
