import 'package:bloc/bloc.dart';
import 'package:equatable/equatable.dart';
import 'package:syncrow_web/pages/space_management_v2/modules/space_details/domain/models/space_details_model.dart';

part 'space_details_model_event.dart';

class SpaceDetailsModelBloc extends Bloc<SpaceDetailsModelEvent, SpaceDetailsModel> {
  SpaceDetailsModelBloc({
    required SpaceDetailsModel initialState,
  }) : super(initialState) {
    on<UpdateSpaceDetailsIcon>(_onUpdateSpaceDetailsIcon);
    on<UpdateSpaceDetailsName>(_onUpdateSpaceDetailsName);
    on<UpdateSpaceDetailsSubspaces>(_onUpdateSpaceDetailsSubspaces);
    on<UpdateSpaceDetailsProductAllocations>(
        _onUpdateSpaceDetailsProductAllocations);
  }

  void _onUpdateSpaceDetailsIcon(
    UpdateSpaceDetailsIcon event,
    Emitter<SpaceDetailsModel> emit,
  ) {
    emit(state.copyWith(icon: event.icon));
  }

  void _onUpdateSpaceDetailsName(
    UpdateSpaceDetailsName event,
    Emitter<SpaceDetailsModel> emit,
  ) {
    emit(state.copyWith(spaceName: event.name));
  }

  void _onUpdateSpaceDetailsSubspaces(
    UpdateSpaceDetailsSubspaces event,
    Emitter<SpaceDetailsModel> emit,
  ) {
    emit(state.copyWith(subspaces: event.subspaces));
  }

  void _onUpdateSpaceDetailsProductAllocations(
    UpdateSpaceDetailsProductAllocations event,
    Emitter<SpaceDetailsModel> emit,
  ) {
    emit(state.copyWith(productAllocations: event.productAllocations));
  }
}
